<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoFormaComunicacao extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $cdformacomu        = $itens['CDFORMACOMU']         ?? null;
        $cdprefixcomuparc   = $itens['CDPREFIXCOMUPARC']    ?? null;
        $cdcomunicaparc     = $itens['CDCOMUNICAPARC']      ?? null;
        $nrorg              = Utils::getParamters()->getNrorg();
        $nrvinculom         = $this->getSolicitacao()->getNrvinculom();
        
        if (is_null($cdformacomu)) {
            throw new \Exception("Solicitação sem tipo de forma de comunicação informada. Favor reprovar e incluir uma nova solicitação");
        }
        
        if (is_null($cdcomunicaparc)) {
            throw new \Exception("Solicitação sem forma de comunicação informada. Favor reprovar e incluir uma nova solicitação");
        }
        
        $result = Utils::getEntityManager()->getRepository(Repositories::GPE_VINCULOM)->findOneBy(array("nrorg"=> $nrorg,"nrvinculom" => $nrvinculom));
        $result = Utils::getEntityManager()->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> $nrorg,"nrpessoa" => $result->getNrpessoa()));
        $comunica = Utils::getEntityManager()->getRepository(Repositories::COMUNICAPARC)->findOneBy(array("nrorg"=> $nrorg,"nrparcnegocio" => $result->getNrparcnegocio(), "cdformacomu" => $cdformacomu));
        
        if($comunica){
            if(!is_null($cdprefixcomuparc))
                $comunica->setCdprefixcomuparc($cdprefixcomuparc);
            
            $comunica->setCdcomunicaparc($cdcomunicaparc);
        }
        else {
            $comunicaParc = Repositories::COMUNICAPARC;
            $comunica = new $comunicaParc;
            $comunica->setNrcomunicaparc(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'COMUNICAPARC', 1, 12, true));
            $comunica->setNrparcnegocio($result->getNrparcnegocio());
            $comunica->setCdprefixcomuparc($cdprefixcomuparc);
            $comunica->setCdcomunicaparc($cdcomunicaparc);
            $comunica->setCdformacomu($cdformacomu);
            $comunica->setNrorg(Utils::getParamters()->getNrorg());
            $comunica->setDtinclusao(DateUtil::getDataAtual(false));
            $comunica->setNrorginclusao(Utils::getParamters()->getNrorg());
            $comunica->setCdoperinclusao(Utils::getParamters()->getCdoperador());
            
        }
       
        Utils::getEntityManager()->persist($comunica);
        Utils::getEntityManager()->flush();
    }
    
    public function rejeitar() {}
}