<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class HierarquiaRepository {
    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->connection = $entityManager->getConnection();
    }

    public function getTiposHierarquia(
        array $params
    ): array {
        $sql = <<<SQL
            SELECT
                HO.*,
                EREL.NMTIPOESTRUTURA AS NMTIPOESTRUTREL,
                ESUP.NMTIPOESTRUTURA AS NMTIPOESTRUTSUP
            FROM
                TIPOHIERARQORG HO
                INNER JOIN
                TIPOESTRUTURA EREL ON
                    HO.NRTIPOESTRUTREL = EREL.NRTIPOESTRUTURA AND
                    (
                        HO.NRORG = EREL.NRORG OR
                        EREL.NRORG = :P_NRORG_PADRAO
                    )
                LEFT JOIN TIPOESTRUTURA ESUP ON
                    HO.NRTIPOESTRUTSUP = ESUP.NRTIPOESTRUTURA AND
                    (
                        HO.NRORG = ESUP.NRORG OR
                        ESUP.NRORG = :P_NRORG_PADRAO
                    )
            WHERE
                (
                    HO.NRORG = :P_NRORG OR
                    HO.NRORG = :P_NRORG_PADRAO
                )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $result = $std->fetchAll();

        return $result;
    }
}