<?php

namespace Teknisa\Model\Teknisa\Repositories;

use Doctrine\ORM\EntityRepository;

class MtDesignEstrutura extends EntityRepository
{
    /**
     * @param $repositoryName
     * @param $initNumber
     * @param $pendFiles
     * @return array
     */
    public function getDeployMigration($repositoryName, $initNumber, $pendFiles)
    {
        $query = <<<SQL
		    SELECT MTD.ID, MTD.SCRIPT, MTD.DSDESESTRUTURA, MTD.IDRESULTSCRIPT, 
                   MTD.NRSCRIPT, MTD.REPOSITORIO_ID, MTR.DSURLREPOSITORIO,
                   CASE WHEN MTD.NRSCRIPT IN ($pendFiles)
                        THEN 'S'
                        ELSE 'N'
                    END AS IDARQPENDENTE
              FROM MT_DESIGN_ESTRUTURA MTD
        INNER JOIN MT_REPOSITORIO MTR ON MTR.ID = MTD.REPOSITORIO_ID
             WHERE MTD.IDATIVO = 'S'
               AND MTD.IDRESULTSCRIPT = 'ES'
               AND MTR.DSURLREPOSITORIO = :REPOSITORY_NAME
               AND (MTD.NRSCRIPT > TO_NUMBER(:INIT_NUMBER)  OR MTD.NRSCRIPT IN ($pendFiles))
          ORDER BY MTD.NRSCRIPT
SQL;
        $param = array(
            'REPOSITORY_NAME' => $repositoryName,
            'INIT_NUMBER'     => $initNumber
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $param);
    }

    /**
     * @param $repositoryName
     * @return array
     */
    public function getMaxMigrationNumber($repositoryName)
    {
        $query = <<<SQL
		        SELECT MAX(MTD.NRSCRIPT) AS NRSCRIPT
                  FROM MT_DESIGN_ESTRUTURA MTD
            INNER JOIN MT_REPOSITORIO MTR ON MTR.ID = MTD.REPOSITORIO_ID
                 WHERE MTD.IDATIVO = 'S'
                   AND MTD.IDRESULTSCRIPT = 'ES'
                   AND MTR.DSURLREPOSITORIO = :REPOSITORY_NAME
                   AND MTD.NRSCRIPT IS NOT NULL
SQL;
        $param = array(
            'REPOSITORY_NAME' => $repositoryName
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $param);
        return empty($result) ? 0 : $result[0]['NRSCRIPT'];
    }
}
